From f1e2de8edd5d4aff802dcc7c4801e4834f51e8ba Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?=E5=A7=9C=E6=B5=B7=E5=A4=A9?= <1076168468@qq.com>
Date: Tue, 25 Oct 2022 14:56:16 +0800
Subject: [PATCH] =?UTF-8?q?=E4=BD=BF=E7=94=A8pc.c?=
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

---
 EOSApp.c | 171 +++++++++++++++++++++++++++++++++++++++++++++++++++++--
 1 file changed, 165 insertions(+), 6 deletions(-)

diff --git a/EOSApp.c b/EOSApp.c
index d8f2bae..d9756f6 100644
--- a/EOSApp.c
+++ b/EOSApp.c
@@ -1,5 +1,36 @@
+/*
+ṩʾΪ˲һ߽һԣ
+ȫıʵ˲ӦӦóվʹøʾ롣
+ڳʾԤ;ʹɵżȻ̷ʧ
+ӢʱƼ޹˾еκΡ
+*/
+
 #include "EOSApp.h"
 
+//
+// ء
+//
+#define BUFFER_SIZE		10
+int Buffer[BUFFER_SIZE];
+
+//
+// Ʒ
+//
+#define PRODUCT_COUNT	30
+
+//
+// ߺͬĶ
+//
+HANDLE MutexHandle;
+HANDLE EmptySemaphoreHandle;
+HANDLE FullSemaphoreHandle;
+
+//
+// ߺߵ̺߳
+//
+ULONG Producer(PVOID Param);
+ULONG Consumer(PVOID Param);
+
 //
 // main 壺
 // argc - argv ĳȣСΪ 1argc - 1 Ϊв
@@ -13,14 +44,142 @@
 int main(int argc, char* argv[])
 {
 	//
-	// ҪڵӦóʱܹԽں˲ʾӦԴ룬
-	// ʹ EOS ںĿȫ汾 SDK ļУȻ
-	// ʹøոɵ SDK ļиǴӦóĿе SDK ļ
-	// У EOS ںĿڴϵλòܸı䡣
+	//  EOS ӦóǰҪرע⣺
+	//
+	// 1ҪڵӦóʱܹԽں˲ʾӦԴ룬
+	//    ʹ EOS Ŀȫ汾 SDK ļУȻ
+	//    ʹôļиӦóĿе SDK ļУ EOS
+	//    Ŀڴϵλòܸı䡣
+	//
+	
+	HANDLE ProducerHandle;
+	HANDLE ConsumerHandle;
+
+	//
+	// ڻʻص Mutex 
+	//
+	MutexHandle = CreateMutex(FALSE, NULL);
+	if (NULL == MutexHandle) {
+		return 1;
+	}
+
+	//
+	//  Empty źʾпջʼΪ BUFFER_SIZE
+	//
+	EmptySemaphoreHandle = CreateSemaphore(BUFFER_SIZE, BUFFER_SIZE, NULL);
+	if (NULL == EmptySemaphoreHandle) {
+		return 2;
+	}
+
+	//
+	//  Full źʾʼΪ 0Ϊ BUFFER_SIZE
+	//
+	FullSemaphoreHandle = CreateSemaphore(0, BUFFER_SIZE, NULL);
+	if (NULL == FullSemaphoreHandle) {
+		return 3;
+	}
+
+	//
+	// ̡߳
+	//
+	ProducerHandle = CreateThread( 0,			// Ĭ϶ջС
+								   Producer,	// ̺߳ڵַ
+								   NULL,		// ̺߳
+								   0,			// ־
+								   NULL );		// ߳ ID
+
+	if (NULL == ProducerHandle) {
+		return 4;
+	}
+
 	//
+	// ̡߳
+	//
+	ConsumerHandle = CreateThread( 0,
+								   Consumer,
+								   NULL,
+								   0,
+								   NULL );
+
+	if (NULL == ConsumerHandle) {
+		return 5;
+	}
+
+	//
+	// ȴ̺߳߳̽
+	//
+	WaitForSingleObject(ProducerHandle, INFINITE);
+	WaitForSingleObject(ConsumerHandle, INFINITE);
+	
+	//
+	// رվ
+	//
+	CloseHandle(MutexHandle);
+	CloseHandle(EmptySemaphoreHandle);
+	CloseHandle(FullSemaphoreHandle);
+	CloseHandle(ProducerHandle);
+	CloseHandle(ConsumerHandle);
+
+	return 0;
+}
+
+//
+// ̺߳
+//
+ULONG Producer(PVOID Param) 
+{
+	int i;
+	int InIndex = 0;
+
+	for (i = 0; i < PRODUCT_COUNT; i++) {
+
+		WaitForSingleObject(EmptySemaphoreHandle, INFINITE);
+		WaitForSingleObject(MutexHandle, INFINITE);
+
+		printf("Produce a %d\n", i);
+		Buffer[InIndex] = i;
+		InIndex = (InIndex + 1) % BUFFER_SIZE;
+
+		ReleaseMutex(MutexHandle);
+		ReleaseSemaphore(FullSemaphoreHandle, 1, NULL);
+
+		//
+		// Ϣһᡣÿ 500 һ
+		//
+		Sleep(500);
+	}
+	
+	return 0;
+}
+
+//
+// ̺߳
+//
+ULONG Consumer(PVOID Param)
+{
+	int i;
+	int OutIndex = 0;
+
+	for (i = 0; i < PRODUCT_COUNT; i++) {
+
+		WaitForSingleObject(FullSemaphoreHandle, INFINITE);
+		WaitForSingleObject(MutexHandle, INFINITE);
+
+		printf("\t\t\tConsume a %d\n", Buffer[OutIndex]);
+		OutIndex = (OutIndex + 1) % BUFFER_SIZE;
 
-	/* TODO: ڴ˴ԼĴ */
-	printf("Hello world!\n");
+		ReleaseMutex(MutexHandle);
+		ReleaseSemaphore(EmptySemaphoreHandle, 1, NULL);
 
+		//
+		// Ϣһǰ 10 ٶȱȽĽϿ졣
+		//
+		if (i < 10) {
+			Sleep(2000);
+		} else {
+			Sleep(100);
+		}
+	}
+	
 	return 0;
 }
-- 
2.34.1.windows.1

